#ifndef AREA_HPP_INCLUDED
#define AREA_HPP_INCLUDED

#include "Tile.hpp"
#include "Convex.hpp"
#include <vector>
#include <cstdint>

/** @addtogroup Types
* @{ */
class Area
{
	private:
		std::int32_t Plane;
		std::vector<Tile> Vertices;

    public:
        Area();
        Area(const Tile& TopLeft, const Tile& BottomRight);
        Area(const std::vector<Tile>& Vertices);
        Area(const Area& A);

		bool Valid() const;
        bool Contains(const Tile& T) const;
        Tile GetMiddle() const;
		std::int32_t GetPlane() const;
		std::vector<Tile> GetVertices() const;

        friend std::ostream& operator<<(std::ostream& OS, const Area& A);
        ~Area();
};

/** @} */

#endif // AREA_HPP_INCLUDED
